#include <stdlib.h>
#include <stdio.h>

#ifndef LINKED_LIST
#include "linkedList.h"
#endif

#ifndef HOOKS
#include "hooks.h"
#endif

void printA() {
  printf("A\n");  
}

void printB() {
  printf("B\n");
}

void printC() {
  printf("C\n");
}

int main(int argc, char **argv)
{
  HOOK * theHook = initializeHook(1);
  addToHook(theHook, printA);
  printf("Running with just printA:\n");
  runHook(theHook);
  addToHook(theHook, printB);
  printf("With printA and printB:\n");
  runHook(theHook);
  addToHook(theHook, printC);
  printf("With printA, printB and printC:\n");
  runHook(theHook);
  addToHook(theHook, printA);
  printf("With printA, printB, printC and printB:\n");
  runHook(theHook);
}
